
/*  A Bison parser, made from ../../gcc/treelang/parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	RIGHT_BRACE	257
#define	LEFT_BRACE	258
#define	RIGHT_SQUARE_BRACKET	259
#define	LEFT_SQUARE_BRACKET	260
#define	RIGHT_PARENTHESIS	261
#define	LEFT_PARENTHESIS	262
#define	SEMICOLON	263
#define	ASTERISK	264
#define	COMMA	265
#define	EQUALS	266
#define	ASSIGN	267
#define	PLUS	268
#define	MINUS	269
#define	INTEGER	270
#define	IF	271
#define	ELSE	272
#define	RETURN	273
#define	CHAR	274
#define	INT	275
#define	UNSIGNED	276
#define	VOID	277
#define	TYPEDEF	278
#define	NAME	279
#define	STATIC	280
#define	AUTOMATIC	281
#define	EXTERNAL_DEFINITION	282
#define	EXTERNAL_REFERENCE	283
#define	WHITESPACE	284
#define	COMMENT	285
#define	PROD_VARIABLE_NAME	286
#define	PROD_TYPE_NAME	287
#define	PROD_FUNCTION_NAME	288
#define	PROD_INTEGER_CONSTANT	289
#define	PROD_PLUS_EXPRESSION	290
#define	PROD_MINUS_EXPRESSION	291
#define	PROD_ASSIGN_EXPRESSION	292
#define	PROD_VARIABLE_REFERENCE_EXPRESSION	293
#define	PROD_PARAMETER	294
#define	PROD_FUNCTION_INVOCATION	295

#line 1 "../../gcc/treelang/parse.y"
 /* -*- c -*- emacs mode c */
  /* 

     TREELANG Compiler parser.  

     ---------------------------------------------------------------------

     Copyright (C) 1999, 2000, 2001 Free Software Foundation, Inc.

     This program is free software; you can redistribute it and/or modify it
     under the terms of the GNU General Public License as published by the
     Free Software Foundation; either version 2, or (at your option) any
     later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, 59 Temple Place - Suite 330,
     Boston, MA 02111-1307, USA.

     In other words, you are welcome to use, share and improve this program.
     You are forbidden to forbid anyone else to use, share and improve
     what you give them.   Help stamp out software-hoarding!  

     ---------------------------------------------------------------------

     Written by Tim Josling 1999-2001, based in part on other parts of
     the GCC compiler.
 
   */

  /* 

     Grammar Conflicts
     *****************

     Here are no conflicts in this grammar.  Please keep it that way.

   */

typedef void* tree;

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gansidecl.h"

#include "treelang.h"
#include "treetree.h"

#define YYDEBUG 1
#define YYPRINT(file, type, value) print_token (file, type, value) 
#define YYERROR_VERBOSE YES

/* Local prototypes.  */

static void yyerror (const char *error_message);
int yylex (void);
int yyparse (void);
void print_token (FILE * file, unsigned int  type ATTRIBUTE_UNUSED, YYSTYPE value);
static struct production* reverse_prod_list (struct production* old_first);
static void ensure_not_void (unsigned int type, struct token* name);
static int check_type_match (int type_num, struct production* exp);
static int get_common_type (struct production* type1, struct production* type2);
static struct production* make_integer_constant (struct token* value);
static void set_storage (struct production* prod);

/* File global variables.  */

static struct production* current_function=NULL;

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		93
#define	YYFLAG		-32768
#define	YYNTBASE	42

#define YYTRANSLATE(x) ((unsigned)(x) <= 295 ? yytranslate[x] : 72)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     6,     9,    11,    13,    15,    21,    23,
    25,    27,    29,    32,    40,    41,    48,    49,    51,    52,
    54,    56,    59,    61,    64,    66,    69,    71,    73,    77,
    79,    82,    85,    88,    90,    91,    92,    93,   108,   111,
   112,   114,   116,   118,   122,   126,   130,   134,   136,   141,
   143,   147,   149,   150,   152,   155
};

static const short yyrhs[] = {    -1,
    43,    44,     0,    45,     0,    44,    45,     0,    46,     0,
    49,     0,    50,     0,    47,    55,    25,    69,     9,     0,
    26,     0,    27,     0,    28,     0,    29,     0,    55,    25,
     0,    47,    55,    25,     8,    56,     7,     9,     0,     0,
    25,     4,    51,    52,    53,     3,     0,     0,    54,     0,
     0,    57,     0,    46,     0,    54,    46,     0,    21,     0,
    22,    21,     0,    20,     0,    22,    20,     0,    23,     0,
    48,     0,    56,    11,    48,     0,    58,     0,    57,    58,
     0,    65,     9,     0,    63,     9,     0,    59,     0,     0,
     0,     0,    17,     8,    65,     7,    60,     4,    53,     3,
    61,    18,    62,     4,    53,     3,     0,    19,    64,     0,
     0,    65,     0,    16,     0,    68,     0,    65,    14,    65,
     0,    65,    15,    65,     0,    65,    12,    65,     0,    68,
    13,    65,     0,    66,     0,    25,     8,    67,     7,     0,
    65,     0,    67,    11,    65,     0,    25,     0,     0,    70,
     0,    13,    71,     0,    16,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   133,   137,   143,   147,   152,   156,   159,   164,   208,   210,
   211,   212,   215,   236,   311,   346,   355,   359,   364,   368,
   373,   377,   382,   392,   401,   410,   419,   430,   435,   443,
   447,   452,   458,   461,   466,   475,   478,   483,   491,   534,
   538,   548,   552,   555,   584,   613,   642,   669,   674,   746,
   753,   762,   795,   799,   803,   808
};
#endif

#define YYNTOKENS 42
#define YYNNTS 30
#define YYNRULES 56
#define YYNSTATES 94
#define YYMAXUTOK 295

static const char * const yytname[] = {   "$","error","$undefined.","RIGHT_BRACE",
"LEFT_BRACE","RIGHT_SQUARE_BRACKET","LEFT_SQUARE_BRACKET","RIGHT_PARENTHESIS",
"LEFT_PARENTHESIS","SEMICOLON","ASTERISK","COMMA","EQUALS","ASSIGN","PLUS","MINUS",
"INTEGER","IF","ELSE","RETURN","CHAR","INT","UNSIGNED","VOID","TYPEDEF","NAME",
"STATIC","AUTOMATIC","EXTERNAL_DEFINITION","EXTERNAL_REFERENCE","WHITESPACE",
"COMMENT","PROD_VARIABLE_NAME","PROD_TYPE_NAME","PROD_FUNCTION_NAME","PROD_INTEGER_CONSTANT",
"PROD_PLUS_EXPRESSION","PROD_MINUS_EXPRESSION","PROD_ASSIGN_EXPRESSION","PROD_VARIABLE_REFERENCE_EXPRESSION",
"PROD_PARAMETER","PROD_FUNCTION_INVOCATION","file","@1","declarations","declaration",
"variable_def","storage","parameter","function_prototype","function","@2","variable_defs_opt",
"statements_opt","variable_defs","typename","parameters","statements","statement",
"if_statement","@3","@4","@5","return","expression_opt","expression","function_invocation",
"expressions_with_commas","variable_ref","init_opt","init","init_element", NULL
};
static const short yytoknum[] = { 0,
   256,     2,   257,   258,   259,   260,   261,   262,   263,   264,
   265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
   285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
   295,     0
};

static const short yyr1[] = {     0,
    43,    42,    44,    44,    45,    45,    45,    46,    47,    47,
    47,    47,    48,    49,    51,    50,    52,    52,    53,    53,
    54,    54,    55,    55,    55,    55,    55,    56,    56,    57,
    57,    58,    58,    58,    60,    61,    62,    59,    63,    64,
    64,    65,    65,    65,    65,    65,    65,    65,    66,    67,
    67,    68,    69,    69,    70,    71
};

static const short yyr2[] = {     0,
     0,     2,     1,     2,     1,     1,     1,     5,     1,     1,
     1,     1,     2,     7,     0,     6,     0,     1,     0,     1,
     1,     2,     1,     2,     1,     2,     1,     1,     3,     1,
     2,     2,     2,     1,     0,     0,     0,    14,     2,     0,
     1,     1,     1,     3,     3,     3,     3,     1,     4,     1,
     3,     1,     0,     1,     2,     1
};

static const short yydefact[] = {     1,
     0,     0,     9,    10,    11,    12,     2,     3,     5,     0,
     6,     7,    15,     4,    25,    23,     0,    27,     0,    17,
    26,    24,    53,    21,     0,    19,    18,     0,     0,     0,
    54,     0,    42,     0,    40,    52,     0,    20,    30,    34,
     0,     0,    48,    43,    22,    28,     0,     0,    56,    55,
     8,    53,     0,    39,    41,     0,    16,    31,    33,    32,
     0,     0,     0,     0,    13,     0,     0,     0,    50,     0,
    46,    44,    45,    47,    14,    29,    35,    49,     0,     0,
    51,    19,     0,    36,     0,    37,     0,    19,     0,    38,
     0,     0,     0
};

static const short yydefgoto[] = {    91,
     1,     7,     8,     9,    10,    46,    11,    12,    20,    26,
    37,    27,    47,    48,    38,    39,    40,    80,    85,    87,
    41,    54,    42,    43,    70,    44,    30,    31,    50
};

static const short yypact[] = {-32768,
    14,    16,-32768,-32768,-32768,-32768,    14,-32768,-32768,    31,
-32768,-32768,-32768,-32768,-32768,-32768,    15,-32768,     7,    29,
-32768,-32768,    25,-32768,    31,   -14,    29,    31,    18,    50,
-32768,    35,-32768,    53,   -12,    54,    60,   -14,-32768,-32768,
    55,    10,-32768,    52,-32768,-32768,    41,    38,-32768,-32768,
-32768,    56,   -12,-32768,    -6,   -12,-32768,-32768,-32768,-32768,
   -12,   -12,   -12,   -12,-32768,    58,    31,     0,    -6,    39,
    -6,    57,    57,    33,-32768,-32768,-32768,-32768,   -12,    64,
    -6,   -14,    67,-32768,    59,-32768,    69,   -14,    68,-32768,
    74,    75,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,    71,   -10,     3,     9,-32768,-32768,-32768,-32768,
   -51,-32768,    -9,-32768,-32768,    42,-32768,-32768,-32768,-32768,
-32768,-32768,   -35,-32768,-32768,-32768,-32768,-32768,-32768
};


#define	YYLAST		80


static const short yytable[] = {    55,
    19,    33,    34,    33,    35,    61,    77,    62,    63,    24,
    36,    61,    36,    62,    63,    32,    45,    68,    60,    13,
    69,    61,    25,    62,    63,    71,    72,    73,    74,    25,
    83,    23,    28,    49,    21,    22,    89,    29,     2,     3,
     4,     5,     6,    81,    66,    78,    62,    63,    67,    79,
    15,    16,    17,    18,     3,     4,     5,     6,    51,    52,
    53,    56,    57,    59,    64,    65,    75,    82,    29,    84,
    90,    63,    88,    92,    93,    76,    86,    14,     0,    58
};

static const short yycheck[] = {    35,
    10,    16,    17,    16,    19,    12,     7,    14,    15,    20,
    25,    12,    25,    14,    15,    25,    27,    53,     9,     4,
    56,    12,    20,    14,    15,    61,    62,    63,    64,    27,
    82,    25,     8,    16,    20,    21,    88,    13,    25,    26,
    27,    28,    29,    79,     7,     7,    14,    15,    11,    11,
    20,    21,    22,    23,    26,    27,    28,    29,     9,    25,
     8,     8,     3,     9,    13,    25,     9,     4,    13,     3,
     3,    15,     4,     0,     0,    67,    18,     7,    -1,    38
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 134 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 2:
#line 137 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 3:
#line 144 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 4:
#line 147 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 5:
#line 153 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 6:
#line 156 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 7:
#line 159 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 8:
#line 165 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  tok = yyvsp[-2];
  prod = make_production (PROD_VARIABLE_NAME, tok);
  SYMBOL_TABLE_NAME (prod) = tok;
  EXPRESSION_TYPE (prod) = yyvsp[-3];
  VAR_INIT (prod) = yyvsp[-1];
  NUMERIC_TYPE (prod) = NUMERIC_TYPE (( (struct production*)EXPRESSION_TYPE (prod)));
  ensure_not_void (NUMERIC_TYPE (prod), tok);
  if (insert_tree_name (prod))
    {
      YYERROR;
    }
  STORAGE_CLASS_TOKEN (prod) = yyvsp[-4];
  set_storage (prod);

  if (VAR_INIT (prod))
    {
      if (! ((struct production*)VAR_INIT (prod))->code)
        abort ();
    if (STORAGE_CLASS (prod) == EXTERNAL_REFERENCE_STORAGE)
      {
        fprintf (stderr, "%s:%i:%i: External reference variables may not have initial value\n", in_fname, 
                tok->lineno, tok->charno);
        print_token (stderr, 0, tok);
        errorcount++;
        YYERROR;
      }
    }
  prod->code = tree_code_create_variable
    (STORAGE_CLASS (prod), 
     ((struct token*)SYMBOL_TABLE_NAME (prod))->chars,
     ((struct token*)SYMBOL_TABLE_NAME (prod))->length,
     NUMERIC_TYPE (prod),
     VAR_INIT (prod)? ((struct production*)VAR_INIT (prod))->code:NULL,
     in_fname,
     tok->lineno);
  if (!prod->code) 
    abort ();
;
    break;}
case 13:
#line 216 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  struct production* prod2;
  tok = yyvsp[0];
  prod = make_production (PROD_VARIABLE_NAME, tok);
  SYMBOL_TABLE_NAME (prod) = yyvsp[0];
  EXPRESSION_TYPE (prod) = yyvsp[-1];
  NUMERIC_TYPE (prod) = NUMERIC_TYPE (( (struct production*)EXPRESSION_TYPE (prod)));
  ensure_not_void (NUMERIC_TYPE (prod), tok);
  if (insert_tree_name (prod))
    {
      YYERROR;
    }
  prod2 = make_production (PROD_PARAMETER, tok);
  VARIABLE (prod2) = prod;
  yyval = prod2;
;
    break;}
case 14:
#line 237 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  struct production* type;
  struct tree_parameter_list* first_parms;
  struct tree_parameter_list* last_parms;
  struct tree_parameter_list* this_parms;
  struct production* this_parm;
  struct production* this_parm_var;
  tok = yyvsp[-4];
  prod = make_production (PROD_FUNCTION_NAME, yyvsp[-4]);
  SYMBOL_TABLE_NAME (prod) = yyvsp[-4];
  EXPRESSION_TYPE (prod) = yyvsp[-5];
  NUMERIC_TYPE (prod) = NUMERIC_TYPE (( (struct production*)EXPRESSION_TYPE (prod)));
  PARAMETERS (prod) = reverse_prod_list (yyvsp[-2]); 
  insert_tree_name (prod);
  STORAGE_CLASS_TOKEN (prod) = yyvsp[-6];
  set_storage (prod);
  switch (STORAGE_CLASS (prod))
    { 
    case STATIC_STORAGE:
    case EXTERNAL_DEFINITION_STORAGE:
      break;
      
    case AUTOMATIC_STORAGE:
      fprintf (stderr, "%s:%i:%i: A function cannot be automatic\n", in_fname, 
              tok->lineno, tok->charno);
      print_token (stderr, 0, tok);
      errorcount++;
      YYERROR;
      break;

    default:
      abort ();
    }
  type = EXPRESSION_TYPE (prod);
  /* Create a parameter list in a non-front end specific format.  */
  for (first_parms = NULL, last_parms = NULL, this_parm = PARAMETERS (prod);
       this_parm;
       this_parm = this_parm->next)
    {
      if (this_parm->category != production_category)
        abort ();
      this_parm_var = VARIABLE (this_parm);
      if (!this_parm_var)
        abort ();
      if (this_parm_var->category != production_category)
        abort ();
      this_parms = my_malloc (sizeof (struct tree_parameter_list));
      if (!this_parm_var->main_token)
        abort ();
      this_parms->variable_name = this_parm_var->main_token->chars;
      this_parms->type = NUMERIC_TYPE (( (struct production*)EXPRESSION_TYPE (this_parm_var)));
      if (last_parms)
        {
          last_parms->next = this_parms;
          last_parms = this_parms;
        }
      else
        {
          first_parms = this_parms;
          last_parms = this_parms;
        }
      this_parms->where_to_put_var_tree = & (( (struct production*)VARIABLE (this_parm))->code);
    }
  FIRST_PARMS (prod) = first_parms;

  prod->code = tree_code_create_function_prototype
    (tok->chars, STORAGE_CLASS (prod), NUMERIC_TYPE (type),
     first_parms, in_fname, tok->lineno);

;
    break;}
case 15:
#line 312 "../../gcc/treelang/parse.y"
{
  struct production* proto;
  struct production search_prod;
  struct token* tok;
  struct production* this_parm;
  tok = yyvsp[-1];
  push_var_level ();
  SYMBOL_TABLE_NAME ((&search_prod)) = tok;
  current_function = proto = lookup_tree_name (&search_prod);
  if (!proto)
    {
      fprintf (stderr, "%s:%i:%i: Function prototype not found\n", in_fname, 
              tok->lineno, tok->charno);
      print_token (stderr, 0, tok);
      errorcount++;
      YYERROR;
    }
  if (!proto->code)
    abort ();
  tree_code_create_function_initial
    (proto->code, in_fname, tok->lineno,
     FIRST_PARMS (current_function));

  /* Check all the parameters have code.  */
  for (this_parm = PARAMETERS (proto);
       this_parm;
       this_parm = this_parm->next)
    {
      if (! (struct production*)VARIABLE (this_parm))
        abort ();
      if (! (( (struct production*)VARIABLE (this_parm))->code))
        abort ();
    }
;
    break;}
case 16:
#line 346 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  tok = yyvsp[-5];
  tree_code_create_function_wrapup (in_fname, tok->lineno);
  current_function = NULL;
  pop_var_level ();
;
    break;}
case 17:
#line 356 "../../gcc/treelang/parse.y"
{
  yyval = 0;
;
    break;}
case 18:
#line 359 "../../gcc/treelang/parse.y"
{
  yyval = yyvsp[0];
;
    break;}
case 19:
#line 365 "../../gcc/treelang/parse.y"
{
  yyval = 0;
;
    break;}
case 20:
#line 368 "../../gcc/treelang/parse.y"
{
  yyval = yyvsp[0];
;
    break;}
case 21:
#line 374 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 22:
#line 377 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 23:
#line 383 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  tok = yyvsp[0];
  prod = make_production (PROD_TYPE_NAME, tok);
  NUMERIC_TYPE (prod) = SIGNED_INT;
  prod->code = tree_code_get_type (NUMERIC_TYPE (prod));
  yyval = prod;
;
    break;}
case 24:
#line 392 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  tok = yyvsp[-1];
  prod = make_production (PROD_TYPE_NAME, tok);
  NUMERIC_TYPE (prod) = UNSIGNED_INT;
  prod->code = tree_code_get_type (NUMERIC_TYPE (prod));
  yyval = prod;
;
    break;}
case 25:
#line 401 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  tok = yyvsp[0];
  prod = make_production (PROD_TYPE_NAME, tok);
  NUMERIC_TYPE (prod) = SIGNED_CHAR;
  prod->code = tree_code_get_type (NUMERIC_TYPE (prod));
  yyval = prod;
;
    break;}
case 26:
#line 410 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  tok = yyvsp[-1];
  prod = make_production (PROD_TYPE_NAME, tok);
  NUMERIC_TYPE (prod) = UNSIGNED_CHAR;
  prod->code = tree_code_get_type (NUMERIC_TYPE (prod));
  yyval = prod;
;
    break;}
case 27:
#line 419 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  tok = yyvsp[0];
  prod = make_production (PROD_TYPE_NAME, tok);
  NUMERIC_TYPE (prod) = VOID_TYPE;
  prod->code = tree_code_get_type (NUMERIC_TYPE (prod));
  yyval = prod;
;
    break;}
case 28:
#line 431 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
  yyval = yyvsp[0];
;
    break;}
case 29:
#line 435 "../../gcc/treelang/parse.y"
{
  struct production* prod1;
  prod1 = yyvsp[0];
  prod1->next = yyvsp[-2]; /* Insert in reverse order.  */
  yyval = prod1;
;
    break;}
case 30:
#line 444 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 31:
#line 447 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 32:
#line 453 "../../gcc/treelang/parse.y"
{
  struct production* exp;
  exp = yyvsp[-1];
  tree_code_output_expression_statement (exp->code, in_fname, exp->main_token->lineno);
;
    break;}
case 33:
#line 458 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 34:
#line 461 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 35:
#line 467 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* exp;
  tok = yyvsp[-3];
  exp = yyvsp[-1];
  ensure_not_void (NUMERIC_TYPE (exp), exp->main_token);
  tree_code_if_start (exp->code, in_fname, tok->lineno);
;
    break;}
case 36:
#line 475 "../../gcc/treelang/parse.y"
{
  /* Just let the statements flow.  */
;
    break;}
case 37:
#line 478 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  tok = yyvsp[-9];
  tree_code_if_else (in_fname, tok->lineno);
;
    break;}
case 38:
#line 483 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  tok = yyvsp[-2];
  tree_code_if_end (in_fname, tok->lineno);
;
    break;}
case 39:
#line 492 "../../gcc/treelang/parse.y"
{
  struct production* type_prod;
  struct token* ret_tok;
  ret_tok = yyvsp[-1];
  type_prod = EXPRESSION_TYPE (current_function);
  if (NUMERIC_TYPE (type_prod) == VOID)
    if (yyvsp[0] == NULL)
      tree_code_generate_return (type_prod->code, NULL);
    else
      {
        fprintf (stderr, "%s:%i:%i: Redundant expression in return\n", in_fname, 
                ret_tok->lineno, ret_tok->charno);
        print_token (stderr, 0, ret_tok);
        errorcount++;
        tree_code_generate_return (type_prod->code, NULL);
      }
  else
    if (yyvsp[0] == NULL)
      {
        fprintf (stderr, "%s:%i:%i: Expression missing in return\n", in_fname, 
                ret_tok->lineno, ret_tok->charno); 
        print_token (stderr, 0, ret_tok);
        errorcount++;
      }
    else
      {
        struct production* exp;
        exp = yyvsp[0];
        /* Check same type.  */
        if (check_type_match (NUMERIC_TYPE (type_prod), yyvsp[0]))
          {
            if (!type_prod->code)
              abort ();
            if (!exp->code)
              abort ();
            /* Generate the code. */
            tree_code_generate_return (type_prod->code, exp->code);
          }
      }
;
    break;}
case 40:
#line 535 "../../gcc/treelang/parse.y"
{
  yyval = 0;
;
    break;}
case 41:
#line 538 "../../gcc/treelang/parse.y"
{
  struct production* exp;
  exp = yyvsp[0];
  if (!exp->code)
    abort ();
  
  yyval = yyvsp[0];
;
    break;}
case 42:
#line 549 "../../gcc/treelang/parse.y"
{
  yyval = make_integer_constant (yyvsp[0]);
;
    break;}
case 43:
#line 552 "../../gcc/treelang/parse.y"
{
  yyval = yyvsp[0];
;
    break;}
case 44:
#line 555 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  struct production* op1;
  struct production* op2;
  tree type;
  
  op1 = yyvsp[-2];
  op2 = yyvsp[0];
  tok = yyvsp[-1];
  ensure_not_void (NUMERIC_TYPE (op1), op1->main_token);
  ensure_not_void (NUMERIC_TYPE (op2), op2->main_token);
  prod = make_production (PROD_PLUS_EXPRESSION, tok);
  NUMERIC_TYPE (prod) = get_common_type (op1, op2);
  if (!NUMERIC_TYPE (prod))
    YYERROR;
  else 
    {
      type = get_type_for_numeric_type (NUMERIC_TYPE (prod));
      if (!type)
        abort ();
      OP1 (prod) = yyvsp[-2];
      OP2 (prod) = yyvsp[0];
      
      prod->code = tree_code_get_expression
        (EXP_PLUS, type, op1->code, op2->code, NULL);
    }
  yyval = prod;
;
    break;}
case 45:
#line 584 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  struct production* op1;
  struct production* op2;
  tree type;
  
  op1 = yyvsp[-2];
  op2 = yyvsp[0];
  ensure_not_void (NUMERIC_TYPE (op1), op1->main_token);
  ensure_not_void (NUMERIC_TYPE (op2), op2->main_token);
  tok = yyvsp[-1];
  prod = make_production (PROD_PLUS_EXPRESSION, tok);
  NUMERIC_TYPE (prod) = get_common_type (op1, op2);
  if (!NUMERIC_TYPE (prod))
    YYERROR;
  else 
    {
      type = get_type_for_numeric_type (NUMERIC_TYPE (prod));
      if (!type)
        abort ();
      OP1 (prod) = yyvsp[-2];
      OP2 (prod) = yyvsp[0];
      
      prod->code = tree_code_get_expression (EXP_MINUS, 
                                          type, op1->code, op2->code, NULL);
    }
  yyval = prod;
;
    break;}
case 46:
#line 613 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  struct production* op1;
  struct production* op2;
  tree type;
  
  op1 = yyvsp[-2];
  op2 = yyvsp[0];
  ensure_not_void (NUMERIC_TYPE (op1), op1->main_token);
  ensure_not_void (NUMERIC_TYPE (op2), op2->main_token);
  tok = yyvsp[-1];
  prod = make_production (PROD_PLUS_EXPRESSION, tok);
  NUMERIC_TYPE (prod) = SIGNED_INT;
  if (!NUMERIC_TYPE (prod))
    YYERROR;
  else 
    {
      type = get_type_for_numeric_type (NUMERIC_TYPE (prod));
      if (!type)
        abort ();
      OP1 (prod) = yyvsp[-2];
      OP2 (prod) = yyvsp[0];
      
      prod->code = tree_code_get_expression (EXP_EQUALS, 
                                          type, op1->code, op2->code, NULL);
    }
  yyval = prod;
;
    break;}
case 47:
#line 642 "../../gcc/treelang/parse.y"
{
  struct token* tok;
  struct production* prod;
  struct production* op1;
  struct production* op2;
  tree type;
  
  op1 = yyvsp[-2];
  op2 = yyvsp[0];
  tok = yyvsp[-1];
  ensure_not_void (NUMERIC_TYPE (op2), op2->main_token);
  prod = make_production (PROD_ASSIGN_EXPRESSION, tok);
  NUMERIC_TYPE (prod) = NUMERIC_TYPE (op1);
  if (!NUMERIC_TYPE (prod))
    YYERROR;
  else 
    {
      type = get_type_for_numeric_type (NUMERIC_TYPE (prod));
      if (!type)
        abort ();
      OP1 (prod) = yyvsp[-2];
      OP2 (prod) = yyvsp[0];
      prod->code = tree_code_get_expression (EXP_ASSIGN, 
                                          type, op1->code, op2->code, NULL);
    }
  yyval = prod;
;
    break;}
case 48:
#line 669 "../../gcc/treelang/parse.y"
{
  yyval = yyvsp[0];
;
    break;}
case 49:
#line 675 "../../gcc/treelang/parse.y"
{
  struct production* prod;
  struct token* tok;
  struct production search_prod;
  struct production* proto;
  struct production* exp;
  struct production* exp_proto;
  struct production* var;
  int exp_proto_count;
  int exp_count;
  tree parms;
  tree type;
  
  tok = yyvsp[-3];
  prod = make_production (PROD_FUNCTION_INVOCATION, tok);
  SYMBOL_TABLE_NAME (prod) = tok;
  PARAMETERS (prod) = reverse_prod_list (yyvsp[-1]);
  SYMBOL_TABLE_NAME ((&search_prod)) = tok;
  proto = lookup_tree_name (&search_prod);
  if (!proto)
    {
      fprintf (stderr, "%s:%i:%i: Function prototype not found\n", in_fname, 
              tok->lineno, tok->charno);
      print_token (stderr, 0, tok);
      errorcount++;
      YYERROR;
    }
  EXPRESSION_TYPE (prod) = EXPRESSION_TYPE (proto);
  NUMERIC_TYPE (prod) = NUMERIC_TYPE (proto);
  /* Count the expressions and ensure they match the prototype.  */
  for (exp_proto_count = 0, exp_proto = PARAMETERS (proto); 
       exp_proto; exp_proto = exp_proto->next)
    exp_proto_count++;

  for (exp_count = 0, exp = PARAMETERS (prod); exp; exp = exp->next)
    exp_count++;

  if (exp_count !=  exp_proto_count)
    {
      abort ();
      fprintf (stderr, "%s:%i:%i: expression count mismatch with prototype\n", in_fname, 
              tok->lineno, tok->charno);
      print_token (stderr, 0, tok);
      errorcount++;
      YYERROR;
    }
  parms = tree_code_init_parameters ();
  for (exp_proto = PARAMETERS (proto), exp = PARAMETERS (prod);
       exp_proto;
       exp = exp->next, exp_proto = exp_proto->next)
  {
    if (!exp)
      abort ();
    if (!exp_proto)
      abort ();
    if (!exp->code)
      abort ();
    var = VARIABLE (exp_proto);
    if (!var)
      abort ();
    if (!var->code)
      abort ();
    parms = tree_code_add_parameter (parms, var->code, exp->code);
  }
  type = get_type_for_numeric_type (NUMERIC_TYPE (prod));
  prod->code = tree_code_get_expression
    (EXP_FUNCTION_INVOCATION, type, proto->code, parms, NULL);
  yyval = prod;
;
    break;}
case 50:
#line 747 "../../gcc/treelang/parse.y"
{
  struct production* exp;
  exp = yyvsp[0];
  ensure_not_void (NUMERIC_TYPE (exp), exp->main_token);
  yyval = yyvsp[0];
;
    break;}
case 51:
#line 753 "../../gcc/treelang/parse.y"
{
  struct production* exp;
  exp = yyvsp[0];
  ensure_not_void (NUMERIC_TYPE (exp), exp->main_token);
  exp->next = yyvsp[-2]; /* Reverse order.  */
  yyval = exp;
;
    break;}
case 52:
#line 763 "../../gcc/treelang/parse.y"
{
  struct production search_prod;
  struct production* prod;
  struct production* symbol_table_entry;
  struct token* tok;
  tree type;

  tok = yyvsp[0];
  SYMBOL_TABLE_NAME ((&search_prod)) = tok;
  symbol_table_entry = lookup_tree_name (&search_prod);
  if (!symbol_table_entry)
    {
      fprintf (stderr, "%s:%i:%i: Variable referred to but not defined\n", in_fname, 
              tok->lineno, tok->charno);
      print_token (stderr, 0, tok);
      errorcount++;
      YYERROR;
    }

  prod = make_production (PROD_VARIABLE_REFERENCE_EXPRESSION, tok);
  NUMERIC_TYPE (prod) = NUMERIC_TYPE (symbol_table_entry);
  type = get_type_for_numeric_type (NUMERIC_TYPE (prod));
  if (!NUMERIC_TYPE (prod))
    YYERROR;
  OP1 (prod) = yyvsp[0];
  
  prod->code = tree_code_get_expression (EXP_REFERENCE, type, 
                                      symbol_table_entry->code, NULL, NULL);
  yyval = prod;
;
    break;}
case 53:
#line 796 "../../gcc/treelang/parse.y"
{
  yyval = 0;
;
    break;}
case 54:
#line 799 "../../gcc/treelang/parse.y"
{
  /* Nothing to do.  */
;
    break;}
case 55:
#line 804 "../../gcc/treelang/parse.y"
{
;
    break;}
case 56:
#line 809 "../../gcc/treelang/parse.y"
{
  yyval = make_integer_constant (yyvsp[0]);
;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (int)(sizeof(yytname) / (int)sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (int)(sizeof(yytname) / (int)sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 814 "../../gcc/treelang/parse.y"


/* Print a token VALUE to file FILE.  Ignore TYPE which is the token
   type. */

void
print_token (FILE * file, unsigned int  type ATTRIBUTE_UNUSED, YYSTYPE value) 
{
  struct token *tok;
  unsigned int  ix;

  tok  =  value;
  fprintf (file, "%d \"", tok->lineno);
  for (ix  =  0; ix < tok->length; ix++)
    fprintf (file, "%c", tok->chars[ix]);
  fprintf (file, "\"");
}

/* Output a message ERROR_MESSAGE from the parser.  */
void
yyerror (const char *error_message)
{
  struct token *tok;
  
  tok = yylval;
  if (tok)
    {
      fprintf (stderr, "%s:%i:%i: %s\n", in_fname, tok->lineno, tok->charno, error_message);
      print_token (stderr, 0, tok);
    }
  else
    fprintf (stderr, "%s\n", error_message);
  
  errorcount++;

}

/* Reverse the order of a token list, linked by parse_next, old first
   token is OLD_FIRST.  */

static struct production*
reverse_prod_list (struct production* old_first)
{
  struct production* current;
  struct production* next;
  struct production* prev = NULL;
  
  current = old_first;
  prev = NULL;

  while (current) 
    {
      if (current->category != production_category)
        abort ();
      next = current->next;
      current->next = prev;
      prev = current;
      current = next; 
    }
  return prev;
}

/* Ensure TYPE is not VOID. Use NAME as the token for the error location.  */

static void
ensure_not_void (unsigned int type, struct token* name)
{
  if (type == VOID)
    {
      fprintf (stderr, "%s:%i:%i: Type must not be void in this context\n", in_fname, 
              name->lineno, name->charno);
      print_token (stderr, 0, name);
      errorcount++;
    }
}

/* Check TYPE1 and TYPE2 which are integral types.  Return the lowest
   common type (min is signed int).  */

static int 
get_common_type (struct production* type1, struct production* type2)
{
  if (NUMERIC_TYPE (type1) == UNSIGNED_INT)
    return UNSIGNED_INT;
  if (NUMERIC_TYPE (type2) == UNSIGNED_INT)
    return UNSIGNED_INT;

  return SIGNED_INT;
}

/* Check type (TYPE_NUM) and expression (EXP) match.  Return the 1 if
   OK else 0.  Must be exact match - same name unless it is an
   integral type.  */

static int 
check_type_match (int type_num, struct production* exp)
{
  switch (type_num)
    {
    case SIGNED_INT:
    case UNSIGNED_INT:
    case SIGNED_CHAR:
    case UNSIGNED_CHAR:
      switch (NUMERIC_TYPE (exp))
        {
        case SIGNED_INT:
        case UNSIGNED_INT:
        case SIGNED_CHAR:
        case UNSIGNED_CHAR:
          return 1;
          
        case VOID:
          abort ();
      
        default: 
          abort ();
        }
      break;
      
    case VOID:
      abort ();
      
    default:
      abort ();
      
    }
}

/* Make a production for an integer constant VALUE.  */

static struct production* 
make_integer_constant (struct token* value)
{
  struct token* tok;
  struct production* prod;
  tok = value;
  prod = make_production (PROD_INTEGER_CONSTANT, tok);
  if ((tok->chars[0] == (unsigned char)'-')|| (tok->chars[0] == (unsigned char)'+'))
    NUMERIC_TYPE (prod) = SIGNED_INT;
  else
    NUMERIC_TYPE (prod) = UNSIGNED_INT;
  prod->code = tree_code_get_integer_value (tok->chars, tok->length);
  return prod;
}

/* Set STORAGE_CLASS in PROD according to CLASS_TOKEN.  */

static void
set_storage (struct production* prod)
{
  struct token* stg_class;
  stg_class = STORAGE_CLASS_TOKEN (prod);
  switch (stg_class->type)
    {
    case STATIC:
      STORAGE_CLASS (prod) = STATIC_STORAGE;
      break;
      
    case AUTOMATIC:
      STORAGE_CLASS (prod) = AUTOMATIC_STORAGE;
      break;
      
    case EXTERNAL_DEFINITION:
      STORAGE_CLASS (prod) = EXTERNAL_DEFINITION_STORAGE;
      break;

    case EXTERNAL_REFERENCE:
      STORAGE_CLASS (prod) = EXTERNAL_REFERENCE_STORAGE;
      break;

    default:
      abort ();
    }
}
